package tycho.surefire.problem.chart;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.birt.chart.model.Chart;
import org.eclipse.birt.chart.model.attribute.ColorDefinition;
import org.eclipse.birt.chart.model.attribute.impl.ColorDefinitionImpl;

import tycho.surefire.problem.chart.LinesChart.LineData;

public class Charts {

	public static long[] randomDates(final int number) {
		final long[] dates = new long[number];
		long lastTimeStamp = System.currentTimeMillis();
		for (int cpt = number - 1; cpt >= 0; cpt--) {
			dates[cpt] = lastTimeStamp;
			lastTimeStamp -= 8 * 60 * 60 * 1000;
		}
		return dates;
	}

	public static final Chart randomLineChart(final int lineNumber, final int pointNumber) {
		final List<LineData> lines = new ArrayList<>(lineNumber);
		for (int i = 0; i < lineNumber; i++) {
			final float min = RandomUtils.randomBoolean() ? -100 : 0;
			final float max = RandomUtils.randomBoolean() && min != 0 ? 0 : 100;
			lines.add(new LineData("Line " + i, Charts.randomColorDefinition(), Charts.randomValues(pointNumber, min, max), RandomUtils.randomBoolean())); //$NON-NLS-1$
		}
		return new LinesChart("Random Line Chart", Charts.randomDates(pointNumber), lines, RandomUtils.randomBoolean(), RandomUtils.randomBoolean()); //$NON-NLS-1$
	}

	public static Double[] randomValues(final int number, final double min, final double max) {
		final Double[] values = new Double[number];
		Double lastValue = 0d;
		for (int i = 0; i < number; i++) {
			final Double random = RandomUtils.randomDouble(0, 25);
			if (RandomUtils.randomBoolean()) {
				lastValue += random;
			} else {
				lastValue -= random;
			}
			if (lastValue < min) {
				lastValue = min;
			}
			if (lastValue > max) {
				lastValue = max;
			}
			values[i] = lastValue;
		}
		return values;
	}
	
	private static final ColorDefinition randomColorDefinition() {
		final int red = RandomUtils.randomInteger(0, 255);
		final int green = RandomUtils.randomInteger(0, 255);
		final int blue = RandomUtils.randomInteger(0, 255);
		return ColorDefinitionImpl.create(red, green, blue);
	}
	
}
